function [g, NR] = regionGrowing_global(f, S, connectivitat)

f = double(f);

%INICIALITZACIO

%Obtenim la mida de la imatge necessaria per a crear les estructures que
%farem servir.
[ample, fons, alt] = size(f);

%Marquem tots els pixels com a no pertanyents a cap regio.
Etiquetes = zeros(ample, fons, alt);

%Comptador de les diferents regions.
N_Regions = 0;


%Estructura de connectivitat
CON=true(3,3,3);
switch connectivitat
    case 6
        CON([5 11 13 14 15 17 23])=0;
    case 18
        CON([2 4 5 6 8 10 11 12 13 14 15 16 17 18 20 22 23 24 26])=0;
    case 26
        CON= ~CON;
    otherwise
        error('Connectiviatat erronea');
end

for k=1:size(S,1)
N_Regions = N_Regions + 1;

fila = S(k,1);
columna = S(k,2);
llesca = S(k,3);

    %Inicialitzem l'estadistic amb el valor del primer pixel no
    %tractat.
    
    Mitjana=0;
    desv=0;
    
    %Crear cua
    maxDades=ample*fons*alt; %Maxim de pixels ja que es vigila que no s'encuin 2 cops.
    CuaEstatica = zeros(maxDades,3); %Cua per a guardar els pixels que poden pertanyer a la mateixa regi�.
    IndexCua = 1; %No hi ha cap element a la cua, el primer element anira a la posicio 1.
    nDades = 0;
    
    %Estructura per controlar els pixels que hi ha a la cua. Ara no hem encuat res.
    Encuats = zeros(ample, fons, alt);

    
    %Guardem els pixels de la regi�.
    PixelsRegio=zeros(maxDades,1);
    nPixels = 0;
    
    PixelsRegio(1)=f(fila,columna,llesca);
    %nPixels = nPixels+1;


%FER CREIXER LA LLAVOR PER A TENIR UN ESTADISTIC INICIAL MES ROBUST
    mida_llavor=2;
    
    mat_llavor = false(ample,fons,alt);
    mat_llavor(fila, columna, llesca)=true;
    
    for ll=1:mida_llavor
    
        mat_llavor = mat_llavor | bwperim(~mat_llavor, connectivitat);

        mat_llavor(1,:,:)=false;
        mat_llavor(ample,:,:)=false;

        mat_llavor(:,1,:)=false;
        mat_llavor(:,fons,:)=false;

        mat_llavor(:,:,1)=false;
        mat_llavor(:,:,alt)=false;
    
    end
%FINAL DEL CREIXEMENT DE LA LLAVOR

%CALCUL DE L'ESTADISTIC INICIAL
    [xll yll zll] = ind2sub(size(mat_llavor),find(mat_llavor));
    
    CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(xll,1)-1, maxDades),:) = [xll yll zll];
    nDades=nDades+size(xll,1);
    Encuats=Encuats | mat_llavor;
    Etiquetes=Etiquetes+(mat_llavor.*N_Regions);
    
    pixels_valor = f(mat_llavor);
  
    PixelsRegio(nPixels+1:nPixels+size(pixels_valor,1))=pixels_valor;
    nPixels = nPixels+size(pixels_valor,1);
        
    Mitjana = mean(PixelsRegio(1:nPixels));
    desv = std(PixelsRegio(1:nPixels),1); %desviacio N-1
   

%INICIALITZACIO DE L'ESTADISTIC
 Quadrats = sum((PixelsRegio(1:nPixels)-Mitjana).^2);
Sumatori = sum(PixelsRegio(1:nPixels));
PixelsImposats = nPixels;

    %creixer        
    while nDades>0
        
        %Agafem el primer
        fila = CuaEstatica(IndexCua,1);
        columna = CuaEstatica(IndexCua,2);
        llesca = CuaEstatica(IndexCua,3);

        %Es treu de la cua.
        IndexCua = mod(IndexCua+1, maxDades);
        nDades = nDades -1;

        %Si es compleix la condicio l'afegim a la regio i encuem els
        %seus pixels veins que no formen part de cap regi�, ni s'han
        %encuat previament per a comprovar si son d'aquesta regio.
        if (f(fila,columna,llesca) >= Mitjana-2.5*desv) && (f(fila,columna,llesca) <= Mitjana+2.5*desv)
            
            %S'afegeix a la regio
            Etiquetes(fila,columna,llesca) = N_Regions;

            
            %Actualitzar estadistic.
            
            if IndexCua > PixelsImposats %Fins que no desencuem tota la llavor no actualitzem l'estadistic
                
                nPixels=nPixels+1;
                Quadrats = Quadrats + (f(fila,columna,llesca)-Mitjana)^2;
                Sumatori = Sumatori + f(fila,columna,llesca);
                Mitjana = Sumatori/nPixels;
                desv = sqrt(Quadrats/(nPixels-1)); %desv N-1                
            end
            %Encuar els veins, si no estan encuats, ni etiquetats.
            if(fila>1 && fila<ample && columna>1 && columna<fons && llesca>1 && llesca<alt) %Si no passa els l�mits
                
                SubEtiquetes = Etiquetes(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);
                SubEncuats = Encuats(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);

                [x y z] = ind2sub(size(CON),find(~(CON | SubEtiquetes | SubEncuats)));
                
                CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(x,1)-1, maxDades),:) = [(x-2)+fila (y-2)+columna (z-2)+llesca];
                nDades=nDades+size(x,1);
                Encuats(sub2ind(size(Encuats), (x-2)+fila, (y-2)+columna, (z-2)+llesca))=true;
            end
        end
    end
end

%Carreguem les sortides.
%g = label2rgb(Etiquetes, 'colorcube', 'c', 'shuffle');
g = Etiquetes; 
NR = N_Regions;
