function [g, NR] = regionGrowing_local_finestra(f, S, connectivitat, Mida_radi_finestra)

f = double(f);

%INICIALITZACIO

%Obtenim la mida de la imatge necessaria per a crear les estructures que
%farem servir.
[ample, fons, alt] = size(f);

%Marquem tots els pixels com a no pertanyents a cap regio.
Etiquetes = zeros(ample, fons, alt);

%Comptador de les diferents regions.
N_Regions = 0;


%Poligon connectivitat
CON=true(3,3,3);
switch connectivitat
    case 6
        CON([5 11 13 14 15 17 23])=0;
    case 18
        CON([2 4 5 6 8 10 11 12 13 14 15 16 17 18 20 22 23 24 26])=0;
    case 26
        CON= ~CON;
    otherwise
        error('Connectiviatat erronea');
end

%Matriu per mirar distancies
Mida_radi_finestra=Mida_radi_finestra;
Matriu_distancies = zeros(Mida_radi_finestra*2+1,Mida_radi_finestra*2+1, Mida_radi_finestra*2+1);

for r=1:Mida_radi_finestra*2+1
    for s=1:Mida_radi_finestra*2+1
        for t=1:Mida_radi_finestra*2+1
            Matriu_distancies(s,r,t)=sqrt((Mida_radi_finestra+1-r)^2+(Mida_radi_finestra+1-s)^2+(Mida_radi_finestra+1-t)^2);
        end
    end
end

Matriu_distancies(Matriu_distancies>Mida_radi_finestra)=0;
Mascara_distancies = Matriu_distancies>0;


%Fer el volum gran per deixar la mida del Radi pels costats i segmetnar
%tota la imatge (Mirar la condicio per controlar si s'agreguen mes pixels o
%no)


f2 = zeros(size(f)+2*Mida_radi_finestra);

f2(Mida_radi_finestra+1:size(f,1)+Mida_radi_finestra,Mida_radi_finestra+1:size(f,2)+Mida_radi_finestra,Mida_radi_finestra+1:size(f,3)+Mida_radi_finestra)=f;

S=S+Mida_radi_finestra;

for k=1:size(S,1)
N_Regions = N_Regions + 1;

fila = S(k,1);
columna = S(k,2);
llesca = S(k,3);


    %Crear cua
    maxDades=ample*fons*alt; %Maxim de pixels ja que es vigila que no s'encuin 2 cops.
    CuaEstatica = zeros(maxDades,3); %Cua per a guardar els pixels que poden pertanyer a la mateixa regi�.
    IndexCua = 1; %No hi ha cap element a la cua, el primer element anira a la posicio 1.
    nDades = 0;
    
    %Estructura per controlar els pixels que hi ha a la cua. Ara no hem encuat res.
    Encuats = zeros(ample, fons, alt);

    
    mida_llavor=2;
    
    mat_llavor = false(ample,fons,alt);
    mat_llavor(fila, columna, llesca)=true;
    
    for ll=1:mida_llavor
    
        mat_llavor = mat_llavor | bwperim(~mat_llavor, connectivitat);

        mat_llavor(1,:,:)=false;
        mat_llavor(ample,:,:)=false;

        mat_llavor(:,1,:)=false;
        mat_llavor(:,fons,:)=false;

        mat_llavor(:,:,1)=false;
        mat_llavor(:,:,alt)=false;
    
    end
    
    [xll yll zll] = ind2sub(size(mat_llavor),find(mat_llavor));
    
    CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(xll,1)-1, maxDades),:) = [xll yll zll];
    nDades=nDades+size(xll,1);
    Encuats=Encuats | mat_llavor;
    Etiquetes=Etiquetes+(mat_llavor.*N_Regions);
    

%nPixels = 0; %Atencio: Estic menyspreant els de la primera iteracio.

    %creixer        
    while nDades>0

        %Agafem el primer
        fila = CuaEstatica(IndexCua,1);
        columna = CuaEstatica(IndexCua,2);
        llesca = CuaEstatica(IndexCua,3);

        %Es treu de la cua.
        IndexCua = mod(IndexCua+1, maxDades);
        nDades = nDades - 1;

            
        Tall = Etiquetes(fila-Mida_radi_finestra:fila+Mida_radi_finestra, columna-Mida_radi_finestra:columna+Mida_radi_finestra, llesca-Mida_radi_finestra:llesca+Mida_radi_finestra);

        Tall_2= f2(fila-Mida_radi_finestra:fila+Mida_radi_finestra, columna-Mida_radi_finestra:columna+Mida_radi_finestra, llesca-Mida_radi_finestra:llesca+Mida_radi_finestra);

        Tall_regio = Tall==N_Regions;

        Tall_enmascarat = Tall_regio&Mascara_distancies;

        Mitjana = mean(Tall_2(Tall_enmascarat));
        desv = std(Tall_2(Tall_enmascarat));
        
        
        %Si es compleix la condicio l'afegim a la regio i encuem els
        %seus pixels veins que no formen part de cap regi�, ni s'han
        %encuat previament per a comprovar si son d'aquesta regio.
        if (f2(fila,columna,llesca) > Mitjana-2.5*desv) && (f2(fila,columna,llesca) < Mitjana+2.5*desv)
            %Marcar regio
            Etiquetes(fila,columna,llesca) = N_Regions;

            
            %Encuar els veins
            if(fila>1+Mida_radi_finestra && fila<ample-Mida_radi_finestra && columna>Mida_radi_finestra+1 && columna<fons-Mida_radi_finestra && llesca>1+Mida_radi_finestra && llesca<alt-Mida_radi_finestra) %Si no passa els l�mits
            %if(fila>1 && fila<ample && columna>1 && columna<fons && llesca>1 && llesca<alt) %Si no passa els l�mits
                
                SubEtiquetes = Etiquetes(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);
                SubEncuats = Encuats(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);

                [x y z] = ind2sub(size(CON),find(~(CON | SubEtiquetes | SubEncuats)));
                
                CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(x,1)-1, maxDades),:) = [(x-2)+fila (y-2)+columna (z-2)+llesca];
                nDades=nDades+size(x,1);
                Encuats(sub2ind(size(Encuats), (x-2)+fila, (y-2)+columna, (z-2)+llesca))=true;
            end
        end
    end
end

%Carreguem les sortides.
%g = label2rgb(Etiquetes, 'colorcube', 'c', 'shuffle');
g = Etiquetes;  
NR = N_Regions;
