function [g, NR] = regionGrowing_local_particions(f, S, connectivitat, mida_x, mida_y, mida_z)

f = double(f);

%INICIALITZACIO

%Obtenim la mida de la imatge necessaria per a crear les estructures que
%farem servir.
[ample, fons, alt] = size(f);

%Marquem tots els pixels com a no pertanyents a cap regio.
Etiquetes = zeros(ample, fons, alt);

%CREAR ESTRUCTURA DE ZONES
Zones = zeros(ample,fons,alt);

for i=0:floor(ample/mida_x)
    for j=0:floor(fons/mida_y)
        for k=0:floor(alt/mida_z)
            Zones(i*mida_x+1:min(i*mida_x+mida_x,ample), j*mida_y+1:min(j*mida_y+mida_y,fons), k*mida_z+1:min(k*mida_z+mida_z,alt))=i*((floor(fons/mida_y)+1)*(floor(alt/mida_z)+1))+j*(floor(alt/mida_z)+1)+k+1;
        end
    end
end
%FINAL CREAR ESTRUCTURA DE ZONES

total_zones=ceil(ample/m)*ceil(fons/n)*ceil(alt/l);

%Comptador de les diferents regions.
N_Regions = 0;


%Estructura de connectivitat
CON=true(3,3,3);
switch connectivitat
    case 6
        CON([5 11 13 14 15 17 23])=0;
    case 18
        CON([2 4 5 6 8 10 11 12 13 14 15 16 17 18 20 22 23 24 26])=0;
    case 26
        CON= ~CON;
    otherwise
        error('Connectiviatat erronea');
end

for k=1:size(S,1)

N_Regions =  N_Regions + 1;

fila = S(k,1);
columna = S(k,2);
llesca = S(k,3);

    %Inicialitzem l'estadistic amb el valor del primer pixel no
    %tractat.
    
    MitjanaLlavor=0;
    desvLlavor=0;
    
    %Crear cua
    maxDades=ample*fons*alt; %Maxim de pixels ja que es vigila que no s'encuin 2 cops.
    CuaEstatica = zeros(maxDades,3); %Cua per a guardar els pixels que poden pertanyer a la mateixa regi�.
    IndexCua = 1; %No hi ha cap element a la cua, el primer element anira a la posicio 1.
    nDades = 0;
    
    %Estructura per controlar els pixels que hi ha a la cua. Ara no hem encuat res.
    Encuats = zeros(ample, fons, alt);

    
    %Guardem els pixels de la regi�.
    PixelsRegio=zeros(maxDades,1);
    nPixelsLlavor = 0;
    
    PixelsRegio(1)=f(fila,columna,llesca);
    %nPixels = nPixels+1;


%FER CREIXER LA LLAVOR PER A TENIR UN ESTADISTIC INICIAL MES ROBUST
    mida_llavor=2;
    
    mat_llavor = false(ample,fons,alt);
    mat_llavor(fila, columna, llesca)=true;
    
    for ll=1:mida_llavor
    
        mat_llavor = mat_llavor | bwperim(~mat_llavor, connectivitat);

        mat_llavor(1,:,:)=false;
        mat_llavor(ample,:,:)=false;

        mat_llavor(:,1,:)=false;
        mat_llavor(:,fons,:)=false;

        mat_llavor(:,:,1)=false;
        mat_llavor(:,:,alt)=false;
    
    end

%CALCUL DE L'ESTADISTIC INICIAL
    [xll yll zll] = ind2sub(size(mat_llavor),find(mat_llavor));
    
    CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(xll,1)-1, maxDades),:) = [xll yll zll];
    nDades=nDades+size(xll,1);
    Encuats=Encuats | mat_llavor;
    Etiquetes=Etiquetes+(mat_llavor.*N_Regions);
    
    pixels_valor = f(mat_llavor);
  
    PixelsRegio(nPixelsLlavor+1:nPixelsLlavor+size(pixels_valor,1))=pixels_valor;
    nPixelsLlavor = nPixelsLlavor+size(pixels_valor,1);
        
    MitjanaLlavor = mean(PixelsRegio(1:nPixelsLlavor));
    desvLlavor = std(PixelsRegio(1:nPixelsLlavor),1); %desviacio N-1
   

%FINAL DEL CREIXEMENT DE LA LLAVOR

%CREAR ESTRUCTURA  HISTORICS ZONES.Son cues de mida igual al numero pixels
%de la llavor.
zona_anterior = 0; %No existeix la zona 0.
zona_actual = 0;
Historic = zeros(total_zones, nPixelsLlavor)-1;%El -1 indicarà els pixels que no contenen cap valor real.
IndexHist = zeros(total_zones,1)+1;
%FINAL CREAR ESTRUCTURA HISTORICS    
    

%INICIALITZACIO DE L'ESTADISTIC

Quadrats = zeros(total_zones,1);
Sumatori = zeros(total_zones,1);
Mitjana = zeros(total_zones,1);
desv = zeros(total_zones,1);
nPixels = zeros(total_zones,1);

zona_actual = Zones(fila,columna,llesca); %Zona del pixel que marquem com a llavor.

Quadrats(zona_actual,1) = sum((PixelsRegio(1:nPixelsLlavor)-MitjanaLlavor).^2);
Sumatori(zona_actual,1) = sum(PixelsRegio(1:nPixelsLlavor));
Historic(zona_actual,1:size(pixels_valor,1)) = pixels_valor;
nPixels(zona_actual,1) = nPixelsLlavor;
IndexHist(zona_actual,1) = max(1,mod(IndexHist(zona_actual,1)+nPixelsLlavor,nPixelsLlavor));
Mitjana(zona_actual,1) = MitjanaLlavor;
desv(zona_actual,1) = desvLlavor;

PixelsImposats = nPixelsLlavor;

    %creixer        
    while nDades>0
        
        %Agafem el primer
        fila = CuaEstatica(IndexCua,1);
        columna = CuaEstatica(IndexCua,2);
        llesca = CuaEstatica(IndexCua,3);

        %Es treu de la cua.
        IndexCua = mod(IndexCua+1, maxDades);
        nDades = nDades -1;

        
        zona_anterior = zona_actual; %Hem de guardar la zona anterior per si canviem de zona.
        zona_actual = Zones(fila,columna,llesca);
        
        %Si es el primer pixel de la zona agafem els estadistics de la zona
        %anterior.
        if nPixels(zona_actual,1)==0
            Historic(zona_actual,:)= Historic(zona_anterior,:);%mai entra el primer cop perque li posem el valor a nPixels.
            IndexHist(zona_actual,1)= IndexHist(zona_anterior,1);
            Mitjana(zona_actual,1) = mean(Historic(zona_actual,Historic(zona_actual,:)>=0)); %agafo els valors valids
            desv(zona_actual,1) = std(Historic(zona_actual,Historic(zona_actual,:)>=0),1);
            nPixels(zona_actual,1)=size(Historic(zona_actual,Historic(zona_actual,:)>=0),2);
            Sumatori(zona_actual,1)=sum(Historic(zona_actual,Historic(zona_actual,:)>=0));
            Quadrats(zona_actual,1)=sum((Historic(zona_actual,Historic(zona_actual,:)>=0)-Mitjana(zona_actual,1)).^2);
        end
        
        %Si es compleix la condicio l'afegim a la regio i encuem els
        %seus pixels veins que no formen part de cap regio, ni s'han
        %encuat previament per a comprovar si son d'aquesta regio.
        if (f(fila,columna,llesca) >= Mitjana(zona_actual,1)-2.5*desv(zona_actual,1)) && (f(fila,columna,llesca) <= Mitjana(zona_actual,1)+2.5*desv(zona_actual,1))
            
            %S'afegeix a la regio
            Etiquetes(fila,columna,llesca) =  N_Regions;
            %Actualitzar estadistic.
            
                
                if IndexCua > PixelsImposats %Fins que no desencuem tota la llavor no actualitzem l'estadistic                
                    nPixels(zona_actual,1)=nPixels(zona_actual)+1;
                    Quadrats(zona_actual,1) = Quadrats(zona_actual,1) + (f(fila,columna,llesca)-Mitjana(zona_actual,1))^2;
                    Sumatori(zona_actual,1) = Sumatori(zona_actual,1) + f(fila,columna,llesca);
                    Mitjana(zona_actual,1) = Sumatori(zona_actual,1)/nPixels(zona_actual,1);
                    desv(zona_actual,1) = sqrt(Quadrats(zona_actual,1)/(nPixels(zona_actual,1)-1)); %desv N-1
                    IndexHist(zona_actual,1)=max(1,mod(IndexHist(zona_actual,1)+1, nPixelsLlavor));
                    Historic(zona_actual,IndexHist(zona_actual,1))=f(fila,columna,llesca);
                end
                %Encuar els veins, si no estan encuats, ni etiquetats.
                if(fila>1 && fila<ample && columna>1 && columna<fons && llesca>1 && llesca<alt) %Si no passa els l�mits

                    SubEtiquetes = Etiquetes(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);
                    SubEncuats = Encuats(fila-1:fila+1,columna-1:columna+1,llesca-1:llesca+1);

                    [x y z] = ind2sub(size(CON),find(~(CON | SubEtiquetes | SubEncuats)));

                    CuaEstatica(mod(IndexCua+nDades, maxDades):mod(IndexCua+nDades+size(x,1)-1, maxDades),:) = [(x-2)+fila (y-2)+columna (z-2)+llesca];
                    nDades=nDades+size(x,1);
                    Encuats(sub2ind(size(Encuats), (x-2)+fila, (y-2)+columna, (z-2)+llesca))=true;
                end
        end
    end
end

%Carreguem les sortides.
%g = label2rgb(Etiquetes, 'colorcube', 'c', 'shuffle');
 g = Etiquetes; 
NR = N_Regions;
